var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useDeep } from '@deep-foundation/deeplinks/imports/client';
import { createContext, memo, useCallback, useEffect, useMemo, useRef, useState } from 'react';
import { ClientHandler, HandlerConfigContext, HandlersGoContext, useFindClientHandler, useHandlersGo } from './client-handler';
import { Alert, AlertIcon, AlertTitle, Box, Button, Flex, Modal, ModalBody, ModalContent, ModalOverlay, Skeleton, useDisclosure, VStack } from '@chakra-ui/react';
import React from 'react';
import uniqBy from 'lodash/uniqBy';
import { Editor } from './editor';
import { useGoCore, GoProvider } from './go';
import $ from 'jquery';
import isEqual from 'lodash/isEqual';
export const r = (path) => {
    if (r.requires[path])
        return r.requires[path];
    throw new Error(`Module not found: Can't resolve ${path}`);
};
r.requires = {};
const dpl = '@deep-foundation/perception-links';
const dc = '@deep-foundation/core';
if (typeof (window) === 'object')
    window._require = r;
export function WatchLink({ link }) {
    const deep = useDeep();
    deep.useSubscription({ id: link.id });
    return null;
}
export function ClientHandlerErrorComponent({ error, reset, handlerId, }) {
    var _a;
    const deep = useDeep();
    const [mode, setMode] = useState('src');
    const handler = useFindClientHandler({ handlerId });
    const { data: [src], loading: _src } = deep.useQuery({ id: (handler === null || handler === void 0 ? void 0 : handler.src_id) && mode === 'src' ? handler === null || handler === void 0 ? void 0 : handler.src_id : 0 });
    const { data: [dist], loading: _dist } = deep.useQuery({ id: (handler === null || handler === void 0 ? void 0 : handler.dist_id) && mode === 'dist' ? handler === null || handler === void 0 ? void 0 : handler.dist_id : 0 });
    const loading = !_src && !_dist;
    const content = { src, dist };
    const disclosure = useDisclosure();
    const _mode = content[mode] ? mode : 'dist';
    const go = useGoCore();
    const ref = useMemo(() => go === null || go === void 0 ? void 0 : go.root().ref, []);
    return React.createElement(React.Fragment, null,
        React.createElement(Button, { w: '100%', h: '100%', variant: 'danger', onClick: disclosure.onOpen }, "error"),
        React.createElement(Modal, { blockScrollOnMount: false, isOpen: disclosure.isOpen, onClose: disclosure.onClose, portalProps: { containerRef: ref } },
            React.createElement(ModalOverlay, null),
            React.createElement(ModalContent, { maxW: '90%', maxH: '90%', h: '100%', opacity: 0.9 },
                React.createElement(ModalBody, { p: '1em' },
                    React.createElement(Flex, { direction: 'column', h: '100%' },
                        React.createElement(Alert, { status: 'error' },
                            React.createElement(AlertIcon, null),
                            React.createElement(AlertTitle, null, "Error:"),
                            React.createElement(Button, { variant: 'danger', onClick: reset }, "reset")),
                        React.createElement(Box, null,
                            React.createElement(Editor, { value: JSON.stringify(error, Object.getOwnPropertyNames(error), 2), editable: false, readOnly: true })),
                        React.createElement(Alert, { status: 'info' },
                            React.createElement(AlertIcon, null),
                            React.createElement(AlertTitle, null,
                                "Handled by ",
                                handlerId,
                                " ",
                                deep.nameLocal(handlerId),
                                ":"),
                            React.createElement(Button, { variant: mode === 'dist' ? 'active' : undefined, onClick: () => setMode('dist') }, "dist"),
                            React.createElement(Button, { variant: mode === 'src' ? 'active' : undefined, onClick: () => setMode('src') }, "src")),
                        !!(content === null || content === void 0 ? void 0 : content[_mode]) && [React.createElement(Box, { flex: 1, key: _mode },
                                React.createElement(Editor, { fillSize: true, linkId: (_a = content === null || content === void 0 ? void 0 : content[_mode]) === null || _a === void 0 ? void 0 : _a.id }))])))));
}
export function ClientHandlerUnhandledComponent({ Component, reset }) {
    return React.createElement(Box, { w: '100%', h: '100%', p: '1em' },
        React.createElement(Skeleton, { h: '3em' }));
}
export function ReactHandlerEditor({ handler, disclosure, }) {
    const deep = useDeep();
    const go = useGoCore();
    const hgo = useHandlersGo();
    const { data: handlers, loading } = deep.useQuery(handler && disclosure.isOpen ? {
        handler_id: { _eq: handler.id },
        return: {
            src: { relation: 'src' },
            dist: { relation: 'dist' },
        },
    } : { limit: 0, handler_id: 0 }, { table: 'handlers' });
    const [file, setFile] = useState();
    useEffect(() => {
        var _a, _b;
        if (!loading && !file && ((_a = handlers === null || handlers === void 0 ? void 0 : handlers[0]) === null || _a === void 0 ? void 0 : _a.src))
            setFile((_b = handlers === null || handlers === void 0 ? void 0 : handlers[0]) === null || _b === void 0 ? void 0 : _b.src);
    }, [loading, handlers]);
    return React.createElement(Modal, { blockScrollOnMount: false, isOpen: disclosure.isOpen, onClose: disclosure.onClose },
        React.createElement(ModalOverlay, null),
        React.createElement(ModalContent, { maxW: '90%', maxH: '90%', h: '100%', opacity: 0.9 },
            React.createElement(ModalBody, { p: '1em' },
                React.createElement(Flex, { direction: 'column', h: '100%' },
                    React.createElement(Box, null, handlers.map(f => {
                        var _a, _b;
                        return React.createElement(React.Fragment, { key: f.handler_id },
                            React.createElement(Box, { display: 'inline-flex' }, (_a = deep.minilinks.byId[f === null || f === void 0 ? void 0 : f.handler_id]) === null || _a === void 0 ? void 0 :
                                _a.id,
                                " ", (_b = deep.minilinks.byId[f === null || f === void 0 ? void 0 : f.handler_id]) === null || _b === void 0 ? void 0 :
                                _b.name),
                            !!f.src && React.createElement(Button, { variant: file === f.src ? 'active' : null, onClick: () => setFile(f.src) }, "src"),
                            !!f.dist && React.createElement(Button, { variant: file === f.dist ? 'active' : null, onClick: () => setFile(f.dist) }, "dist"));
                    })),
                    React.createElement(Box, { flex: 1 }, !loading && !!file && [React.createElement(Editor, { key: file.id, linkId: file.id, fillSize: true })])))));
}
export const ReactHandlersContext = createContext(undefined);
export function ReactHandlersProvider({ children = null, requires = {}, sync: _sync = false, }) {
    var _a, _b;
    r.requires = requires;
    const deep = useDeep();
    const [focuses, setFocuses] = useState([]);
    const focusedRef = useRef([]);
    const focus = useCallback((id, hgo, go) => {
        const f = focusedRef.current;
        const now = new Date().valueOf();
        if (f.timer && now - (f.timer) > 1000) {
            while (f.length > 0)
                f.pop();
        }
        if (!f.timer || now - (f.timer)) {
            f.push({ handlerId: id, go, hgo });
        }
        setFocuses([...f]);
        f.timer = now;
    }, []);
    focusedRef.current.focus = focus;
    const disclosure = useDisclosure();
    const [handler, setHandler] = useState();
    useEffect(() => {
        $(document).on('click', '.deep-link-id', function (e) {
            var _a;
            const handlerId = $(this).data('deep-link-id');
            const go = $(this).data('deep-link-go');
            const hgo = $(this).data('deep-link-handlers-go');
            if (e.shiftKey) {
                focus(handlerId, hgo, go);
            }
            else {
                if (go) {
                    go.do('click');
                    if ((go === null || go === void 0 ? void 0 : go.go) && ((_a = go === null || go === void 0 ? void 0 : go.go) === null || _a === void 0 ? void 0 : _a.value) != (go === null || go === void 0 ? void 0 : go.linkId))
                        go.go.focus(go.linkId);
                }
            }
        });
    }, []);
    const renderFocuses = (list, level = 0, mode = 'hgo') => {
        return uniqBy(list, 'handlerId').map(({ handlerId, go, hgo }) => {
            var _a, _b, _c;
            return React.createElement(React.Fragment, { key: handlerId },
                React.createElement(Box, { mr: `${level * 1}em`, pointerEvents: 'all' },
                    !!go && React.createElement(Button, { bg: 'deepBgDark', size: 'xs', onClick: () => {
                            console.dir(go);
                            window.go = go;
                        } }, "go"),
                    !!hgo && React.createElement(Button, { bg: 'deepBgDark', size: 'xs', onClick: () => {
                            console.dir(hgo);
                            window.hgo = hgo;
                        } }, "hgo"),
                    React.createElement(Button, { bg: 'deepBgDark', size: 'xs', onClick: () => {
                            setHandler(deep.minilinks.byId[handlerId]);
                            disclosure.onOpen();
                        } },
                        handlerId,
                        " ", (_a = deep.minilinks.byId[handlerId]) === null || _a === void 0 ? void 0 :
                        _a.name),
                    !!(go === null || go === void 0 ? void 0 : go.linkId) && React.createElement(Button, { size: 'xs', onClick: () => {
                            setHandler(deep.minilinks.byId[go.linkId]);
                            disclosure.onOpen();
                        } },
                        go.linkId,
                        " ", (_b = deep.minilinks.byId[go.linkId]) === null || _b === void 0 ? void 0 :
                        _b.name),
                    !!(go === null || go === void 0 ? void 0 : go.value) && React.createElement(Button, { size: 'xs', variant: 'active', onClick: () => {
                            setHandler(deep.minilinks.byId[go.value]);
                            disclosure.onOpen();
                        } },
                        go.value,
                        " ", (_c = deep.minilinks.byId[go.value]) === null || _c === void 0 ? void 0 :
                        _c.name)),
                mode === 'hgo' && renderFocuses(Object.values(hgo.children).map((hgo) => ({ handlerId: hgo.linkId, hgo })), level + 1, mode),
                mode === 'go' && renderFocuses(Object.values(go.children).map((go) => ({ handlerId: go.linkId, go })), level + 1, mode));
        });
    };
    const goRoot = (_b = (_a = focuses === null || focuses === void 0 ? void 0 : focuses[0]) === null || _a === void 0 ? void 0 : _a.go) === null || _b === void 0 ? void 0 : _b.root();
    const [sync, setSync] = useState(_sync);
    return React.createElement(ReactHandlersContext.Provider, { value: focusedRef },
        React.createElement(HandlerConfigContext.Provider, { value: { sync, setSync } },
            children,
            !!focuses.length && React.createElement(VStack, { position: 'fixed', top: '0', right: '0', zIndex: 9999, alignItems: 'end', pointerEvents: 'none', userSelect: 'none', overflowY: 'scroll', css: goRoot.noScrollBar },
                React.createElement(Box, { h: '100%', w: '3em', pointerEvents: 'none' }),
                React.createElement(Button, { bg: 'deepBgDark', size: 'md', pointerEvents: 'all', onClick: () => {
                        setFocuses([]);
                    } }, "X"),
                React.createElement(Box, { bg: 'deepBgDark', p: '0.3em', pl: '0.5em', pr: '0.5em' }, "handlers:"),
                renderFocuses(focuses),
                React.createElement(Box, { bg: 'deepBgDark', p: '0.3em', pl: '0.5em', pr: '0.5em' }, "go:"),
                !!goRoot && renderFocuses([{ handlerId: goRoot === null || goRoot === void 0 ? void 0 : goRoot.linkId, go: goRoot }], 0, 'go')),
            !!handler && [React.createElement(ReactHandlerEditor, { key: handler === null || handler === void 0 ? void 0 : handler.id, disclosure: disclosure, handler: handler })]));
}
export const ReactHandler = memo(function ReactHandler(_a) {
    var props = __rest(_a, []);
    const deep = useDeep();
    const go = useGoCore();
    const h = deep.minilinks.byId[props === null || props === void 0 ? void 0 : props.handlerId];
    const ch = React.createElement(ClientHandler, Object.assign({ key: props.handlerId, ErrorComponent: ClientHandlerErrorComponent, UnhandledComponent: ClientHandlerUnhandledComponent }, props, { require: r }),
        React.createElement(GoProvider, { context: HandlersGoContext }, (props === null || props === void 0 ? void 0 : props.children) || null));
    useEffect(() => {
        var _a;
        if (((_a = go === null || go === void 0 ? void 0 : go.go) === null || _a === void 0 ? void 0 : _a.value) === (go === null || go === void 0 ? void 0 : go.linkId)) {
            let counter = 0;
            const i = setInterval(() => {
                var _a, _b, _c;
                if (counter > 30)
                    clearInterval(i);
                counter++;
                if ((_c = (_b = (_a = go()) === null || _a === void 0 ? void 0 : _a.hgo()) === null || _b === void 0 ? void 0 : _b.ref) === null || _c === void 0 ? void 0 : _c.current) {
                    clearInterval(i);
                    go().go().focus(go.linkId);
                }
            }, 100);
            return () => clearInterval(i);
        }
    }, []);
    return React.createElement(React.Fragment, null, [ch]);
}, isEqual);
export function createComponent(props) {
    return useCallback(function (_props) {
        return React.createElement(ReactHandler, Object.assign({}, props, _props));
    }, []);
}
//# sourceMappingURL=react-handler.js.map